=== debian/control ===
Source: ros-melodic-mvsim
Section: misc
Priority: extra
Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-dynamic-reconfigure, ros-melodic-message-generation, ros-melodic-message-runtime, ros-melodic-mrpt-bridge, ros-melodic-mrpt1, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf, ros-melodic-visualization-msgs
Homepage: http://wiki.ros.org/mvsim
Standards-Version: 3.9.2

Package: ros-melodic-mvsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-dynamic-reconfigure, ros-melodic-message-generation, ros-melodic-message-runtime, ros-melodic-mrpt-bridge, ros-melodic-mrpt1, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf, ros-melodic-visualization-msgs
Description: Node for the &quot;multivehicle simulator&quot; framework.
